'use strict';

exports.__esModule = true;

var _css = require('antd/lib/modal/style/css');

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CancelToken = _axios2.default.CancelToken;
var cancel = {};

var Api = function () {
    Api.prototype.post = function post(key, url, data, err) {
        return this._base.post(url, _qs2.default.stringify(data), {
            cancelToken: new CancelToken(function executor(c) {
                // An executor function receives a cancel function as a parameter
                cancel[key] = c;
            })
        }).catch(function (error) {
            if (_axios2.default.isCancel(error)) {
                return void 0;
            };
            var message = '系统错误';
            if (error.response) {
                message = error.response.data.message;
            } else if (error.request) {
                message = error.request;
            } else {
                message = error.message;
            };
            if (err) {
                return err(message);
            };
            _modal2.default.error({
                title: '系统提示',
                content: message
            });
        });
    };

    Api.prototype.get = function get(key, url, data, err) {
        return this._base.get(url, {
            params: data,
            cancelToken: new CancelToken(function executor(c) {
                // An executor function receives a cancel function as a parameter
                cancel[key] = c;
            })
        }).catch(function (error) {
            if (_axios2.default.isCancel(error)) {
                return void 0;
            };
            var message = '系统错误';
            if (error.response) {
                message = error.response.data.message;
            } else if (error.request) {
                message = error.request;
            } else {
                message = error.message;
            };
            if (err) {
                return err(message);
            };
            _modal2.default.error({
                title: '系统提示',
                content: message
            });
        });
    };

    Api.prototype.getCancel = function getCancel(name) {
        return cancel[name];
    };

    Api.prototype.all = function all() {
        for (var _len = arguments.length, request = Array(_len), _key = 0; _key < _len; _key++) {
            request[_key] = arguments[_key];
        }

        return _axios2.default.all(request);
    };

    function Api(_ref) {
        var _this = this;

        var _ref$baseUrl = _ref.baseUrl,
            baseUrl = _ref$baseUrl === undefined ? '' : _ref$baseUrl,
            _ref$apis = _ref.apis,
            apis = _ref$apis === undefined ? {} : _ref$apis;

        _classCallCheck(this, Api);

        this._axios = _axios2.default;

        this._base = _axios2.default.create({
            baseURL: baseUrl
        });

        var _loop = function _loop(key) {
            if (apis[key].mode === 'get') {
                _this[key] = function () {
                    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
                    var error = arguments[1];

                    return _this.get(key, apis[key].url, data, error);
                };
            } else {
                _this[key] = function () {
                    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
                    var error = arguments[1];

                    return _this.post(key, apis[key].url, data, error);
                };
            };
        };

        for (var key in apis) {
            _loop(key);
        };
    }

    return Api;
}();

exports.default = Api;
;